#! /bin/sh

# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ]; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '.*/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done

# Get standard environment variables
PRGDIR=`dirname "$PRG"`

# Only set AJAXSWING_HOME if not already set
[ -z "$AJAXSWING_HOME" ] && AJAXSWING_HOME=`cd "$PRGDIR/../.." ; pwd`

if [ -r "$AJAXSWING_HOME"/bin/setEnv.sh ]; then
  . "$AJAXSWING_HOME"/bin/setEnv.sh
fi

"$JAVA_HOME/bin/java" -version


echo Applying patches...
"$JAVA_HOME/bin/java" -Dcom.creamtec.home="$AJAXSWING_HOME" -cp "$AJAXSWING_HOME/lib/asm-7.1.jar:$AJAXSWING_HOME/lib/asm-tree-7.1.jar:$AJAXSWING_HOME/lib/boot/asboot.jar:$AJAXSWING_HOME/lib/boot/ajsJava.jar" com.creamtec.core.ClassPatcher

echo Repackaging jars...
"$JAVA_HOME/bin/jar" uf ajsJava.jar java

# setupForXvfb.sh removes X11GraphicsEnvironment class from asboot.jar. It should be called only in non-headless mode because we need X11GraphicsEnvironment in headless mode
if [ -n "$(echo $JAVA_OPTS | grep -e '-Djava.awt.headless=false')" ]; then
    . "$AJAXSWING_HOME"/bin/setup/setupForXvfb.sh
fi

echo Deleting temporary files...
rm -rf "$AJAXSWING_HOME/lib/boot/java"
rm -rf "$AJAXSWING_HOME/lib/boot/javax"

echo Re-create Tomcat temp folder
if [ -d "$AJAXSWING_HOME/tomcat/temp" ]; then
    rm -rf "$AJAXSWING_HOME/tomcat/temp"
fi

mkdir "$AJAXSWING_HOME/tomcat/temp"

echo Done

