#! /bin/sh
#
# Shell script to install AjaxSwing libraries for JDK 11

# resolve links - $0 may be a softlink
PRG="$0"

while [ -h "$PRG" ]; do
  ls=`ls -ld "$PRG"`
  link=`expr "$ls" : '.*-> \(.*\)$'`
  if expr "$link" : '.*/.*' > /dev/null; then
    PRG="$link"
  else
    PRG=`dirname "$PRG"`/"$link"
  fi
done

# Get standard environment variables
PRGDIR=`dirname "$PRG"`

# Only set AJAXSWING_HOME if not already set
[ -z "$AJAXSWING_HOME" ] && AJAXSWING_HOME=`cd "$PRGDIR/../.." ; pwd`

if [ -r "$AJAXSWING_HOME"/bin/setEnv.sh ]; then
  . "$AJAXSWING_HOME"/bin/setEnv.sh
fi

echo Copying AjaxSwing libraries for JDK 11...

cp $AJAXSWING_HOME/lib/install/ajaxswing.jar.jdk11 $AJAXSWING_HOME/lib/ajaxswing.jar
cp $AJAXSWING_HOME/lib/install/asboot.jar.jdk11 $AJAXSWING_HOME/lib/boot/asboot.jar
cp $AJAXSWING_HOME/lib/install/ajsForJava.jar.jdk11 $AJAXSWING_HOME/lib/boot/ajsForJava.jar
cp $AJAXSWING_HOME/lib/install/ajsJava.jar.jdk11 $AJAXSWING_HOME/lib/boot/ajsJava.jar
cp $AJAXSWING_HOME/lib/install/ajsApache.jar.jdk11 $AJAXSWING_HOME/lib/boot/ajsApache.jar

. "$AJAXSWING_HOME"/bin/setup/applyPatches.sh

echo Deleting temporary Tomcat files...
rm -r $AJAXSWING_HOME/tomcat/work/*

echo Done
